
; PicBasic Pro Compiler 2.46, (c) 1998, 2005 microEngineering Labs, Inc. All Rights Reserved.  
PM_USED			EQU	1

	INCLUDE	"16F84A.INC"


; Define statements.
#define		OSC		 4
#define		LCD_DREG		 PORTA           
#define		LCD_DBIT		 0               
#define		LCD_RSREG		 PORTA          
#define		LCD_RSBIT		 4              
#define		LCD_EREG		 PORTB           
#define		LCD_EBIT		 0               
#define		LCD_BITS		 4               
#define		LCD_LINES		 2              
#define		LCD_COMMANDUS		 2000       
#define		LCD_DATAUS		 100           
#define		SHIFT_PAUSEUS		 2000       
#define		BUTTON_PAUSE		 100         

RAM_START       		EQU	0000Ch
RAM_END         		EQU	0004Fh
RAM_BANKS       		EQU	00001h
BANK0_START     		EQU	0000Ch
BANK0_END       		EQU	0004Fh
EEPROM_START    		EQU	02100h
EEPROM_END      		EQU	0213Fh

R0              		EQU	RAM_START + 000h
R1              		EQU	RAM_START + 002h
R2              		EQU	RAM_START + 004h
R3              		EQU	RAM_START + 006h
R4              		EQU	RAM_START + 008h
R5              		EQU	RAM_START + 00Ah
R6              		EQU	RAM_START + 00Ch
R7              		EQU	RAM_START + 00Eh
R8              		EQU	RAM_START + 010h
T1              		EQU	RAM_START + 012h
T2              		EQU	RAM_START + 014h
FLAGS           		EQU	RAM_START + 016h
GOP             		EQU	RAM_START + 017h
RM1             		EQU	RAM_START + 018h
RM2             		EQU	RAM_START + 019h
RR1             		EQU	RAM_START + 01Ah
RR2             		EQU	RAM_START + 01Bh
_dB              		EQU	RAM_START + 01Ch
_VOL             		EQU	RAM_START + 01Eh
_dB1             		EQU	RAM_START + 020h
_dB10            		EQU	RAM_START + 021h
PB01            		EQU	RAM_START + 022h
_V_DOWN          		EQU	RAM_START + 023h
_V_MUTE          		EQU	RAM_START + 024h
_V_UP            		EQU	RAM_START + 025h
_PORTL           		EQU	 PORTB
_PORTH           		EQU	 PORTA
_TRISL           		EQU	 TRISB
_TRISH           		EQU	 TRISA
_VOL_R           		EQU	_VOL
_VOL_L           		EQU	_VOL + 001h
_VOL_BYTE0       		EQU	_VOL
_VOL_BYTE1       		EQU	_VOL + 001h
#define _UP_BUT          	_PORTB_1
#define _DOWN_BUT        	_PORTB_2
#define _MUTE_BUT        	_PORTB_3
#define _MUTE            	_PORTB_4
#define _CS              	_PORTB_5
#define _SDI             	_PORTB_6
#define _SCLK            	_PORTB_7
#define _dB_SIGN         	 PB01, 000h
#define _FLAG            	 PB01, 001h
#define _OPTION_REG_7    	 OPTION_REG, 007h
#define _PORTB_1         	 PORTB, 001h
#define _PORTB_2         	 PORTB, 002h
#define _PORTB_3         	 PORTB, 003h
#define _PORTB_4         	 PORTB, 004h
#define _PORTB_5         	 PORTB, 005h
#define _PORTB_6         	 PORTB, 006h
#define _PORTB_7         	 PORTB, 007h

; Constants.
_I               		EQU	000FEh
_CLR             		EQU	00001h
_LINE_1          		EQU	00080h
_LINE_2          		EQU	000C0h
_LINE_3          		EQU	00094h
_LINE_4          		EQU	000D4h
_CGRAM           		EQU	00040h
_SHIFT_L         		EQU	00018h
_SHIFT_R         		EQU	0001Ch
	INCLUDE	"PGA2310P.MAC"
	INCLUDE	"PBPPIC14.LIB"


	ASM?
 DEVICE PIC16F84A, XT_OSC

	ENDASM?


	ASM?
 DEVICE PIC16F84A, WDT_ON

	ENDASM?


	ASM?
 DEVICE PIC16F84A, PWRT_OFF

	ENDASM?


	ASM?
 DEVICE PIC16F84A, PROTECT_OFF

	ENDASM?

	MOVE?CB	000h, TRISA
	MOVE?CB	00Eh, TRISB
	MOVE?CT	000h, _OPTION_REG_7
	MOVE?CB	000h, INTCON
	MOVE?CB	000h, _V_UP
	MOVE?CB	000h, _V_DOWN
	MOVE?CB	000h, _V_MUTE
	MOVE?CB	037h, _VOL_R
	MOVE?CB	037h, _VOL_L
	LOW?T	_MUTE
	HIGH?T	_CS
	HIGH?T	_SDI
	HIGH?T	_SCLK
	GOSUB?L	_SHIFT
	GOSUB?L	_DB_VALUE
	LCDOUT?C	020h
	LCDOUT?C	020h
	LCDOUT?C	020h
	LCDOUT?C	057h
	LCDOUT?C	065h
	LCDOUT?C	06Ch
	LCDOUT?C	063h
	LCDOUT?C	06Fh
	LCDOUT?C	06Dh
	LCDOUT?C	065h
	LCDOUT?C	020h
	LCDOUT?C	021h
	LCDOUT?C	021h
	PAUSE?C	005DCh
	HIGH?T	_MUTE
	GOSUB?L	_dB_LCD
	GOSUB?L	_MUTE_LCD

	LABEL?L	_VOLUME	
	BUTTONPIN?T	_UP_BUT
	BUTTONDS?C	000h
	BUTTONDEL?C	0FEh
	BUTTONRATE?C	07Fh
	BUTTONTS?C	001h
	BUTTON?BL	_V_UP, _VOL_UP
	BUTTONPIN?T	_DOWN_BUT
	BUTTONDS?C	000h
	BUTTONDEL?C	0FEh
	BUTTONRATE?C	07Fh
	BUTTONTS?C	001h
	BUTTON?BL	_V_DOWN, _VOL_DOWN
	BUTTONPIN?T	_MUTE_BUT
	BUTTONDS?C	000h
	BUTTONDEL?C	0FFh
	BUTTONRATE?C	000h
	BUTTONTS?C	001h
	BUTTON?BL	_V_MUTE, _MUTE_CON
	GOTO?L	_VOLUME

	LABEL?L	_VOL_UP	
	CMPEQ?BCL	_VOL_L, 0FFh, _MAX_LIMIT
	ADD?BCB	_VOL_L, 001h, _VOL_L
	ADD?BCB	_VOL_R, 001h, _VOL_R
	GOSUB?L	_SHIFT
	GOSUB?L	_DB_VALUE
	GOSUB?L	_dB_LCD
	GOSUB?L	_MUTE_LCD
	GOTO?L	_VOLUME

	LABEL?L	_VOL_DOWN	
	CMPEQ?BCL	_VOL_L, 001h, _MIN_LIMIT
	SUB?BCB	_VOL_L, 001h, _VOL_L
	SUB?BCB	_VOL_R, 001h, _VOL_R
	GOSUB?L	_SHIFT
	GOSUB?L	_DB_VALUE
	GOSUB?L	_dB_LCD
	GOSUB?L	_MUTE_LCD
	GOTO?L	_VOLUME

	LABEL?L	_MUTE_CON	
	TOGGLE?T	_MUTE
	GOSUB?L	_MUTE_LCD
	GOTO?L	_VOLUME

	LABEL?L	_SHIFT	
	LOW?T	_CS
	PAUSEUS?C	064h
	SHIFTDATA?T	_SDI
	SHIFTCLOCK?T	_SCLK
	SHIFTMODE?C	005h
	SHIFTOUT?WC	_VOL, 010h
	HIGH?T	_CS
	PAUSEUS?C	064h
	HIGH?T	_SDI
	RETURN?	

	LABEL?L	_DB_VALUE	
	CMPLT?BCL	_VOL_L, 0C0h, L00001
	MOVE?CT	001h, _dB_SIGN
	MUL?BCW	_VOL_L, 00Ah, T1
	SUB?CWW	009F6h, T1, T1
	MUL?CWW	005h, T1, T1
	SUB?CWW	00C4Eh, T1, _dB
	DIV?WCB	_dB, 064h, _dB10
	MOD?WCB	_dB, 064h, _dB1
	DIV?BCB	_dB1, 00Ah, _dB1
	GOTO?L	L00002
	LABEL?L	L00001	
	MOVE?CT	000h, _dB_SIGN
	MUL?BCW	_VOL_L, 00Ah, T1
	SUB?CWW	009F6h, T1, T1
	MUL?CWW	005h, T1, T1
	SUB?WCW	T1, 00C4Eh, _dB
	DIV?WCB	_dB, 064h, _dB10
	MOD?WCB	_dB, 064h, _dB1
	DIV?BCB	_dB1, 00Ah, _dB1
	LABEL?L	L00002	
	RETURN?	

	LABEL?L	_dB_LCD	
	MOVE?CT	001h, _FLAG
	CMPEQ?BCB	_dB10, 000h, T1
	CMPEQ?BCB	_dB1, 000h, T2
	LAND?BBW	T1, T2, T2
	CMPF?WL	T2, L00003
	LCDOUT?C	_I
	LCDOUT?C	_CLR
	LCDOUT?C	020h
	LCDOUT?C	056h
	LCDOUT?C	06Fh
	LCDOUT?C	06Ch
	LCDOUT?C	075h
	LCDOUT?C	06Dh
	LCDOUT?C	065h
	LCDOUT?C	020h
	LCDOUTCOUNT?C	000h
	LCDOUTNUM?B	_dB10
	LCDOUTDEC?	
	LCDOUT?C	020h
	LCDOUT?C	064h
	LCDOUT?C	042h
	MOVE?CT	000h, _FLAG
	LABEL?L	L00003	
	CMPEQ?TCB	_FLAG, 001h, T1
	CMPEQ?TCB	_dB_SIGN, 001h, T2
	LAND?BBW	T1, T2, T2
	CMPF?WL	T2, L00005
	LCDOUT?C	_I
	LCDOUT?C	_CLR
	LCDOUT?C	020h
	LCDOUT?C	056h
	LCDOUT?C	06Fh
	LCDOUT?C	06Ch
	LCDOUT?C	075h
	LCDOUT?C	06Dh
	LCDOUT?C	065h
	LCDOUT?C	020h
	LCDOUTCOUNT?C	000h
	LCDOUTNUM?B	_dB10
	LCDOUTDEC?	
	LCDOUT?C	02Eh
	LCDOUTCOUNT?C	000h
	LCDOUTNUM?B	_dB1
	LCDOUTDEC?	
	LCDOUT?C	020h
	LCDOUT?C	064h
	LCDOUT?C	042h
	LABEL?L	L00005	
	CMPEQ?TCB	_FLAG, 001h, T1
	CMPEQ?TCB	_dB_SIGN, 000h, T2
	LAND?BBW	T1, T2, T2
	CMPF?WL	T2, L00007
	LCDOUT?C	_I
	LCDOUT?C	_CLR
	LCDOUT?C	020h
	LCDOUT?C	056h
	LCDOUT?C	06Fh
	LCDOUT?C	06Ch
	LCDOUT?C	075h
	LCDOUT?C	06Dh
	LCDOUT?C	065h
	LCDOUT?C	020h
	LCDOUT?C	02Dh
	LCDOUTCOUNT?C	000h
	LCDOUTNUM?B	_dB10
	LCDOUTDEC?	
	LCDOUT?C	02Eh
	LCDOUTCOUNT?C	000h
	LCDOUTNUM?B	_dB1
	LCDOUTDEC?	
	LCDOUT?C	020h
	LCDOUT?C	064h
	LCDOUT?C	042h
	LABEL?L	L00007	
	RETURN?	

	LABEL?L	_MUTE_LCD	
	CMPNE?TCL	_MUTE, 001h, L00009
	LCDOUT?C	_I
	LCDOUT?C	_LINE_2
	LCDOUT?C	020h
	LCDOUT?C	04Dh
	LCDOUT?C	075h
	LCDOUT?C	074h
	LCDOUT?C	065h
	LCDOUT?C	020h
	LCDOUT?C	04Fh
	LCDOUT?C	046h
	LCDOUT?C	046h
	GOTO?L	L00010
	LABEL?L	L00009	
	LCDOUT?C	_I
	LCDOUT?C	_LINE_2
	LCDOUT?C	020h
	LCDOUT?C	04Dh
	LCDOUT?C	075h
	LCDOUT?C	074h
	LCDOUT?C	065h
	LCDOUT?C	020h
	LCDOUT?C	04Fh
	LCDOUT?C	04Eh
	LCDOUT?C	020h
	LABEL?L	L00010	
	RETURN?	

	LABEL?L	_MAX_LIMIT	
	LCDOUT?C	_I
	LCDOUT?C	_CLR
	LCDOUT?C	020h
	LCDOUT?C	04Dh
	LCDOUT?C	061h
	LCDOUT?C	078h
	LCDOUT?C	020h
	LCDOUT?C	076h
	LCDOUT?C	06Fh
	LCDOUT?C	06Ch
	LCDOUT?C	075h
	LCDOUT?C	06Dh
	LCDOUT?C	065h
	LCDOUT?C	020h
	LCDOUT?C	021h
	LCDOUT?C	021h
	LCDOUT?C	021h
	GOSUB?L	_MUTE_LCD
	GOTO?L	_VOLUME

	LABEL?L	_MIN_LIMIT	
	LCDOUT?C	_I
	LCDOUT?C	_CLR
	LCDOUT?C	020h
	LCDOUT?C	04Dh
	LCDOUT?C	069h
	LCDOUT?C	06Eh
	LCDOUT?C	020h
	LCDOUT?C	076h
	LCDOUT?C	06Fh
	LCDOUT?C	06Ch
	LCDOUT?C	075h
	LCDOUT?C	06Dh
	LCDOUT?C	065h
	LCDOUT?C	020h
	LCDOUT?C	021h
	LCDOUT?C	021h
	LCDOUT?C	021h
	GOSUB?L	_MUTE_LCD
	GOTO?L	_VOLUME
	END?	

	END
